(* parser-sig.sml
 *
 * COPYRIGHT (c) 1995 AT&T Bell Laboratories.
 *)

signature GENERALIZED_REGEXP_PARSER =
  sig

    structure R : GENERALIZED_REGEXP_SYNTAX

    val scan : (char, 'a) StringCvt.reader
	          -> (R.syntax, 'a) StringCvt.reader
	(* read an external representation of a regular expression
	 * from the stream and return an abstract syntax representation
	 *)

  end

signature REGEXP_PARSER = GENERALIZED_REGEXP_PARSER where R = RegExpSyntax
