CM.make "automata-table-lib.cm";
local
functor DFA(T : AUTOMATA_TABLE) =
struct
   open T
   val t = new {min=0, max=255};
   fun trans s cs = (s,map (fn c => go t (s,c)) cs)
   val _  = addState t (1,[(1,1),(2,2),(3,3)])
   val _  = addState t (2,[(1,1),(2,2)])
   val _  = addState t (3,[(1,1),(2,2),(3,1)])
   val _  = addState t (4,[(1,4),(2,4),(3,4),(4,1)])
   val _  = addState t (5,[(2,2)])
   val _  = addState t (6,[(1,1)])
   val _  = addState t (7,[(1,3),(2,3),(3,3),(4,3)])
   val _  = addState t (8,[(1,3),(2,3),(3,3),(4,0)])
   val _  = compress t
end
in
structure D1 = DFA(SparseAutomataTable)
structure D2 = DFA(DenseAutomataTable)
val _  = print "Sparse\n"
val S0 = D1.trans 0 [1,2,3,4] : int * int list
val S1 = D1.trans 1 [1,2,3,4] : int * int list
val S2 = D1.trans 2 [1,2,3,4] : int * int list
val S3 = D1.trans 3 [1,2,3,4] : int * int list
val S4 = D1.trans 4 [1,2,3,4,5] : int * int list
val S5 = D1.trans 5 [1,2,3,4] : int * int list
val S6 = D1.trans 6 [1,2,3,4] : int * int list
val S7 = D1.trans 7 [1,2,3,4] : int * int list
val S8 = D1.trans 8 [1,2,3,4] : int * int list
val a1 = D1.t
val _  = print "Dense\n"
val S0' = D2.trans 0 [1,2,3,4] : int * int list
val S1' = D2.trans 1 [1,2,3,4] : int * int list
val S2' = D2.trans 2 [1,2,3,4] : int * int list
val S3' = D2.trans 3 [1,2,3,4] : int * int list
val S4' = D2.trans 4 [1,2,3,4,5] : int * int list
val S5' = D1.trans 5 [1,2,3,4] : int * int list
val S6' = D1.trans 6 [1,2,3,4] : int * int list
val S7' = D1.trans 7 [1,2,3,4] : int * int list
val S8' = D1.trans 8 [1,2,3,4] : int * int list
val a2 = D2.t
end
