structure LexerTables : LEXER_TABLES =
struct

   (* A skeleton which represents the structure of the match tree
    * when a regexp match succeeds
    *)
   datatype matchtree_skel = SKEL of int * matchtree_skel list

   datatype group_action = OPEN of int | CLOSE of int | OPENCLOSE of int

   (* Tables used by the lexer; these are not completely compressed though *)
   datatype lexer =
      LEXER of
      { base    : int Array.array,   (* state -> table offset *)
        check   : int Array.array,   (* offset -> valid state *)
        next    : int Array.array,   (* offset -> next state *)
        default : int Array.array,   (* state -> default state *)
        equiv   : int Array.array,   (* char -> equiv class *)
        accept  : int Array.array,   (* state -> accept rule; ~1 if none *)
        groups  : group_action list Array.array, (* state -> groups *)
        skels   : matchtree_skel list Array.array, (* rule -> skeleton *)
        start   : int Array.array,   (* context -> start state *)
        start'  : int Array.array,   (* context -> start state (at newline) *)
        numGroups : int,
        numStates : int, 
        eof       : int
      }

end
