(******************************************************************************)
theory Lueng
imports Pure
begin
(******************************************************************************)

(*----------------------------------------------------------------------------*)
(*-- NOTES ------------------------------------------------------------------\<bar>*)
(*----------------------------------------------------------------------------*)
(*
Lueng's source code page:
  http://www.cs.nyu.edu/leunga/sml-software.html
  
The big modification I did was to delete all of his GENERALIZED_REGEXP_SYNTAX,
and other GENERLIZED_... syntax. I did this to hard code it back to the SML/NJ 
normal use of REGEXP_SYNTAX. I did that because of some SML/NJ commands that 
weren't working for Isbelle/ML, and because he was setting the default to be 
non-GENERALIZED.

Look at ml_lueng\..lueng_RegExp_140413_original\RegExp\FrontEnd\syntax-sig.sml,
at the top and bottom of the signature, and you'll see the first I did that, 
which may or may not have been okay.

The bulleted point gives indicates what changes I made to a file.
*)
(*----------------------------------------------------------------------------*)
(*-- Dependencies -----------------------------------------------------------\<bar>*)
(*----------------------------------------------------------------------------*)

ML_file "../mllib/nj/Util/lib-base-sig.sml"
ML_file "../mllib/nj/Util/lib-base.sml"
ML_file "../mllib/nj/Util/ord-key-sig.sml"
ML_file "../mllib/nj/Util/ord-set-sig.sml"
ML_file "../mllib/nj/Util/list-set-fn.sml"
ML_file "../mllib/nj/Util/ord-map-sig.sml"
ML_file "../mllib/nj/Util/list-map-fn.sml"
ML_file "../mllib/nj/Util/splaytree-sig.sml"
ML_file "../mllib/nj/Util/splaytree.sml"
ML_file "../mllib/nj/Util/splay-set-fn.sml" (*
  \<bullet> Unsynchronized.ref.*)
ML_file "../mllib/nj/Util/int-redblack-set.sml" (*
  \<bullet> Unsynchronized.ref.*)
  
(*----------------------------------------------------------------------------*)
(*-- REGULAR EXPRESSIONS ----------------------------------------------------\<bar>*)
(*----------------------------------------------------------------------------*)

(*\<bar>-----------------\<bar>*)
(*\<bar> RegExp/Frontend \<bar>*)
(*\<bar>-----------------\<bar>*)

ML_file "RegExp/RegExp/FrontEnd/syntax-sig.sml" (*
  \<bullet> GENERALIZED_REGEXP_SYNTAX.*)
ML_file "RegExp/RegExp/FrontEnd/syntax.sml" (*
  \<bullet> GENERALIZED_REGEXP_SYNTAX.*)
ML_file "RegExp/RegExp/FrontEnd/parser-sig.sml"
ML_file "RegExp/RegExp/FrontEnd/awk-syntax.sml" (*
  \<bullet> String.explode, Option.valOf.*)
ML_file "RegExp/RegExp/FrontEnd/generic-syntax.sml" (*
  \<bullet> GENERALIZED_REGEXP_SYNTAX, Unsynchronized.ref.*)

(*\<bar>--------------------------------------------------------------------------\<bar>*)  
(*\<bar> ERROR: perl-syntax.sml     \<bar>*)
(*\<bar>--------------------------------------------------------------------------\<bar>*) 
(*
Commenting out "where R = R" eliminates the error in perl-syntax.sml.

This error is not the reason for the error in regexp-fn.sml below.
*)

ML_file "RegExp/RegExp/FrontEnd/perl-syntax.sml" (*
  \<bullet> GENERALIZED_REGEXP_SYNTAX, Char.ord*)

(*\<bar>-----------------------------------------------\<bar>*)  
(*\<bar> RegExp/Glue and RegExp/Backend/engine-sig.sml \<bar>*)
(*\<bar>-----------------------------------------------\<bar>*) 

ML_file "RegExp/RegExp/Glue/match-tree.sml"
ML_file "RegExp/RegExp/Glue/regexp-sig.sml"
ML_file "RegExp/RegExp/BackEnd/engine-sig.sml"(*
  \<bullet> GENERALIZED_REGEXP_ENGINE*)
  
(*\<bar>--------------------------------------------------------------------------\<bar>*)  
(*\<bar> ERROR: Glue/regexp-fn.sml                                                \<bar>*)
(*\<bar>--------------------------------------------------------------------------\<bar>*)
(*
The error in regexp-fn.sml has to do with "match" in "signature REGEXP" of file
regexp-sig.sml above. Lueng's and SML/NJ's are different. However, it could be
that the only problem is that some function needs to be fully qualified, like
with ord, chr, ref, etc.

ERROR MESSAGE: lines 19, 28, 41

  Type error in function application. 
    Function: E.match : 
      (E.R.syntax * ({len: int, pos: 'a} option MatchTree.match_tree -> 'b)) list 
      -> (char, 'a) StringCvt.reader -> ('b, 'a) StringCvt.reader    
    Argument: (map parse l) : (R.syntax * 'a) list
    Reason: Can't unify E.R.syntax with R.syntax (Different type constructors)

SIGNATURE IN "ml_lueng\RegExp\RegExp\Glue\regexp-sig.sml"
    val match : 
    (string * ({pos: 'a, len:int} option MatchTree.match_tree -> 'b)) list
      -> (char,'a) StringCvt.reader -> ('b, 'a) StringCvt.reader

SIGNATURE IN "mllib\nj\RegExp\Glue\regexp-sig.sml"
    val match : (string * ('a match -> 'b)) list
	    -> (char,'a) StringCvt.reader -> ('b, 'a) StringCvt.reader

*)
  
ML_file "RegExp/RegExp/Glue/regexp-fn.sml"

(*\<bar>----------------\<bar>*)
(*\<bar> RegExp/Backend \<bar>*)
(*\<bar>----------------\<bar>*)

ML_file "RegExp/RegExp/BackEnd/bt-engine.sml"
ML_file "RegExp/RegExp/BackEnd/fsm.sml" (*
  \<bullet> List.foldr, List.foldl, Unsynchronized.ref, Option.valOf, Char.chr, 
    Char.ord.*)
ML_file "RegExp/RegExp/BackEnd/dfa-engine.sml"



(******************************************************************************)
end
(******************************************************************************)






